rem %1 is a input directory, with trailing backslash. Can be blank or ".".
rem %2 is a wildcard filename (including extension) of input frames.
rem %3 is the central frame, the name of one of the input files.
rem   If blank or ".", uses the first name.
rem %4 is a prefix for output text files.

@if "%2"=="" findstr /B "rem @rem" %~f0 & exit /B 1

@setlocal enabledelayedexpansion

@call echoOffSave

set InFrames=%1
set WILDFILE=%2
set FIRSTFILE=%3
set OUTPREF=%4

set InExt=%~x2
set InExt=%InExt:~1%

set cnfPref=%~n4


if "%InFrames%"=="." set InFrames=

if "%FIRSTFILE%"=="." set FIRSTFILE=

if "%OUTPREF%"=="." set OUTPREF=
if "%OUTPREF%"=="" set OUTPREF=cs_

set OUT_ALL=%OUTPREF%_all.lis
set OUT_BWD=%OUTPREF%_bwd.lis
set OUT_FWD=%OUTPREF%_fwd.lis

if not exist %InFrames% (
  echo %0: Directory InFrames [%InFrames%] does not exist.
  exit /B 1
)

(
  for /F "usebackq" %%F in (`dir /b /on %InFrames%%WILDFILE%`) do echo %%~nF
)>%OUT_ALL%

set NUMF=0
set NUMBWD=0
set NUMFWD=0
:: STATE: 0=before first, 1=first file, 2=after first
set STATE=0
for /F %%F in (%OUT_ALL%) do (
  echo %%F
  set /A NUMF+=1
  if "!FIRSTFILE!"=="" if !STATE!==0 if !NUMBWD!==0 (
    set STATE=1
    set FIRSTFILE=%%F
  )
  if %%F==!FIRSTFILE! (
    set STATE=1
  )
  if !STATE!==0 (
    set FILEBEF[!NUMBWD!]=%%F
    set /A NUMBWD+=1
  )
  if !STATE!==2 (
    set /A NUMFWD+=1
    echo %%F>>%OUT_FWD%
  )
  if !STATE!==1 (
    set STATE=2
    set FILEBEF[!NUMBWD!]=%%F
    echo %%F>%OUT_FWD%
  )
)

if %NUMF%==0 (
  echo %0: No files in [%InFrames%] match [%WILDFILE%]
  exit /B 1
)

if not %STATE%==2 (
  echo %0: could not find [%FIRSTFILE%] in [%OUT_ALL%]
  exit /B 1
)

del %OUT_BWD% 2>nul
for /L %%I in (%NUMBWD%,-1,0) do (
  echo !FILEBEF[%%I]!>>%OUT_BWD%
)

echo NUMF=%NUMF% NUMBWD=%NUMBWD% NUMFWD=%NUMFWD%

set %cnfPref%.InFrames=%InFrames%
set %cnfPref%.InExt=%InExt%
@call %PICTBAT%chainWrEnv %OUTPREF%
if ERRORLEVEL 1 exit /B 1

call echoRestore

@endlocal & set %cnfPref%.InFrames=%InFrames%& set %cnfPref%.InExt=%InExt%
